﻿package {	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.ui.Mouse;
    import flash.media.Microphone;
    import flash.system.Security;
    import flash.system.SecurityPanel;
	
	public class Particles1 extends Sprite{
		private var bmpData:BitmapData;
		private var filterObj:BlurFilter = new BlurFilter(10,10,1);
		private var particuleCollection:Array=[];
		private var couleursCollection:Array=[0xff81f8f0,0xffffffff,0xef4e06ff];
		
		var myMic:Microphone = Microphone.getMicrophone();
		Security.showSettings(SecurityPanel.MICROPHONE);
		
		public function Particles1(){
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void{

			Mouse.hide();
			bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			addChild(new Bitmap(bmpData)) as Bitmap;
			addEventListener(Event.ENTER_FRAME,boucle);
		}
		private function boucle(e:Event):void{
			for(var i:int=0;i<100;i++){
				var angle:int=Math.round(Math.random()*360);
				creationDeParticules(Math.cos(angle/180*Math.PI)*Math.random()*15,Math.sin(angle/180*Math.PI)*Math.random()*15,couleursCollection[Math.round(Math.random())],mouseX,mouseY);
			}
			var o:int = particuleCollection.length;
			
			myMic.setLoopBack(true);
			myMic.setUseEchoSuppression(true);
			var sounder:Number = myMic.activityLevel*4;
			
			bmpData.applyFilter(bmpData,bmpData.rect,new Point(0,sounder/2),filterObj);
			bmpData.lock();
			while(o--) {
				var p:Object = particuleCollection[o];
				p.x+=p.vx;
				p.y+=p.vy;
				p.vx*=.95;
				p.vy*=.95;
				
				bmpData.setPixel32(p.x,p.y,p.c);
				if (p.vx+p.vy<0.2 && p.vx+p.vy>-0.2){particuleCollection.splice(o,1);}
			}
			bmpData.unlock();
		}
		private function creationDeParticules(vitesseX:Number, vitesseY:Number, couleur:uint, positionX:Number=0, positionY:Number=0):void {
			
			myMic.setLoopBack(true);
			myMic.setUseEchoSuppression(true);
			var sounder:Number = myMic.activityLevel*10;
			
			var particule:Object = {};
			particule.x = stage.height/2;
			particule.y = -stage.width;
			particule.vx = vitesseX;;
			particule.vy = sounder/10;
			particule.c = couleur;
			particuleCollection.push(particule);
		}
	}
}